# Star SamPling

The purpose of this library is to generate [pseudo] random numbers and random
variates. While it is based on C++11 random generators, its API remains pure C.

## How to build

The Star-Sampling library relies on the [CMake](http://www.cmake.org) and the
[RCMake](https://gitlab.com/vaplv/rcmake/) package to build. It also depends on
the [RSys](https://gitlab.com/vaplv/rsys/) library and C++11 random number
generators.

First ensure that CMake and a C++11 compiler is installed on your system. Then
install the RCMake package as well as the RSys library. Finally Generate the
project from the `cmake/CMakeLists.txt` file by appending to the
`CMAKE_PREFIX_PATH` variable the `<RCMAKE_INSTALL_DIR>` and
`<RSYS_INSTALL_DIR>` directories, where `<RCMAKE_INSTALL_DIR>`, and
`<RSYS_INSTALL_DIR>` are the install directories of the RCMake package and the
RSys library, respectively.

### Microsoft Visual Studio

When built with Visual Studio, the Star-Sampling library depends on the
[Boost](http://www.boost.org) random library rather than the STL that is
actually not fully compliant with the C++11 standard.

For this platform, install the Boost random library. Then generate the CMake
project as above with, in addition, the Boost install directory added to the
`CMAKE_PREFIX_PATH` variable and the `BOOST_INCLUDEDIR` cmake variable set to
the path that contains the Boost header directory.

## Licenses

Star-Sampling is Copyright (C) |Meso|Star> 2015-2016
(<contact@meso-star.com>). It is a free software released under the
[OSI](http://opensource.org)-approved CeCILL license. You are welcome to
redistribute it under certain conditions; refer to the COPYING files for
details.

